$! 'f$verify(0)'
$!			VMSGopherServer.COM
$!
$!	27-APR-1994	F.Macrides (macrides@sci.wfbr.edu)
$!			Example htbin script interface to the
$!			VMSIndex search engine (query.exe).
$!			For use with CERN or OSU httpds.
$!			Should be placed where your htbin scripts
$!			have been mapped.
$!
$!	22-AUG-1994	Modified to return complete URL's in cover page. - FM
$!	16-OCT-1994	Added lots of symbol options (see below). - FM
$!	17-JAN-1995	Minor mods of cover page. - FM
$!	13-APR-1995	Added WWW_VMSINDEX_TITLE string. - FM
$!	30-APR-1995	Mods to support searches of sectional databases
$!			in either the server's or users' WWW directories
$!			based on appending of PATH_INFO to the URL. - FM
$!
$!	13-JAN-1996     Updated for query.c v2.4 or later, and
$!	12-JAN-1996	Modified to use a FORM interface by default.  If
$!			WWW_KEY_1 does not begin with "kw", "IDENT" or
$!			"TEXT", reverts to ISINDEX behavior.
$!			example of a FORM-based interface. - FM
$!	19-JAN-1996	Deal with Spyglass Mosaic appending a NAMEd
$!			SUBMIT to the end of the content instead of
$!			in the position encountered. - FM
$!	01-FEB-1996	Added WWW_HITS_TARGET to the Hit List Options
$!			which if non-NULL and a non-zero-length string
$!			will cause TARGET="string" to be added to the
$!			hit list anchors. - FM
$!
$!	Query.c is the search engine developed by Bruce Tanner and Foteos
$!	Macrides for accessing foo.doc;*, foo.IDX;*, foo.SEL;*, and foo.POS
$!	filesets.  The doc file(s) is(are) indexed with BUILD_INDEX.EXE,
$!	yielding the IDX, SEL and POS filesets.
$!
$!	This search engine was develeped by Bruce and colleagues associated
$!	with the VMSGopher-L@trln.lib.unc.edu list for use with the
$!	VMSGopherServer, and was extended by Foteos and Bruce for use with
$!	http servers.  It is similar to WAIS, but uses native indexing
$!	facilities of the VMS Record Management System (RMS).
$!
$!	Build BUILD_INDEX.EXE and QUERY.EXE by executing MAKE.COM.  It will
$!	check out your system and then use MMS or command files, and the
$!	appropriate foo.OPT files.  QUERY.EXE is executed with its /www
$!	qualifier for http servers, normally via a WWWquery foreign command
$!	which includes the qualifier.  The symbol WWW_GATEWAY_INTERFACE,
$!	with is set for CGI scripts by http servers, also acts as a /www
$!	qualifier for query.exe.
$!
$!	Read BUILD_INDEX.DOC for information about the indexer.
$!
$!	This example script is for use with the HTML version of the VMS
$!	Gopher Server documentation, VMSGopherServer.doc, and assumes that
$!	it has been placed either in a doc/gopher/ subdirectory of your
$!	httpd data tree, or the device:[...username.WWWDoc] subdirectory
$!	of user accounts, or both.  The indexes (.IDX, .SEL and .POS files)
$!	should be build with the HTTP_INDEXDOC.COM and HTTP_INDEXUSERDOC.COM
$!	interfaces to the BUILD_INDEX.EXE indexing program (be sure to read
$!	their headers).  If no PATH_INFO in included in the HREF, /www/ is
$!	assumed (i.e, as if you had used HREF="/htbin/vmsgopherserver/www/).
$!	If HREF="/htbin/vmsgopherserver/~username/" is used, the search will
$!	performed for the database and index in username's account.
$!
$!	If no query was included in the client's request, a "database cover
$!	page" is returned.  Modify that section, below, to indicate yourself
$!	and your host as the "database maintainer".  The cover page assumes
$!	that the keywords.html HELP file resides in the /www/doc/ logical
$!	subdirectory.
$!
$!	VMSGopherServer.doc has an anchor pointing to egrep.html, which also
$!	is assumed to reside in the /www/doc/ logical subdirectory.
$! 
$!	The symbol WWW_SHOW_FILETYPE can be made non-NULL (e.g., "YES") to
$!	have icons (or ALT text) indicating the file types to be inserted
$!	into the hit lists returned from searches.
$!
$!	If the symbol WWW_MAXIMUM_HITS is made non-NULL (i.e., set equal to
$!	a number), then the hit lists returned by searches will be abridged,
$!	if necessary, so as not to exceed that number.  The WWW_STARTING_HIT
$!	symbol can be set to a number to indicate the starting number in hit
$!	lists.
$!
$!	The symbol WWW_SHOW_SIZE can be made non-NULL (e.g., "YES") to have
$!	the size of each file or database section indicated in the hit lists.
$!
$!	The symbol WWW_SHOW_DATE can be made non-NULL to have the date of the
$!	database indicated in the hit lists (DD-MMM-YY).  If WWW_SHOW_TIME
$!	also is made non-NULL, for the current year the hour and minute will
$!	be indicated instead of the year (DD-MMM HH:MM).  If WWW_USE_MDATE is
$!	made non-NULL, the date of the last modification (e.g., from an
$!	APPEND) will be used.  The default is the file creation date (i.e.,
$!	of the highest version).
$!
$!	The symbol WWW_VMSINDEX_TITLE can be set to a string for the TITLE
$!	tag in hit lists and section fetches.  Otherwise, the TITLE defaults
$!	to "VMS Indexed Database Search".
$!
$!	The symbol WWW_SEND_CONTENTS can be made non-NULL (e.g., "YES") to
$!	have searches which yield only one hit return that document (instead
$!	of a "hit list" with a link for the document).  This can be used to
$!	fetch particular documents via unique identifiers in them, or other
$!	query known to generate one hit, for that document.
$!
$!	The symbol WWW_SORT can be made non-NULL (e.g., "YES") to invoke
$!	sorting of hits by score, and the symbol WWW_SHOW_SCORE can be made
$!	non-NULL to include the scores in hit list titles.  Setting these
$!	symbols is equivalent to calling query.exe with /sort and /score.
$!
$!	See the header of query.c for additional regulatory symbols.
$!
$!	Set up the foreign command definition for WWWquery, below (or define
$!	it in the CERN server's SpawnInit.COM).  This script must be in the
$!	server's htbin directory, but query.EXE can be anywhere that is
$!	accessible to the server (e.g., where you broke out and built the
$!	VMSIndex distribution).
$!
$!	For the OSU server, you also must have Set_DCL_Env.EXE in its htbin
$!      directory.
$!
$!----------------------------------------------------------------------------
$! WWWquery := "$device:[directory]query/www"
$!----------------------------------------------------------------------------
$ database = "VMSGopherServer"
$!----------------------------------------------------------------------------
$! We'll make this small for the demonstration.  Use a higher value normally.
$ default_max_hits_option = 5	! 5, 10, 25, 50, 100, 150, 250, 500 or 1000
$!----------------------------------------------------------------------------
$ INDEX_DIR = "WWW_Root:[Index]"	! Location of server data tree indexes
$   DOC_REF = "doc/gopher/"		! Server data tree subdir for database
$!----------------------------------------------------------------------------
$ INDEX_SUBDIR = "WWWIndex"	! Homolog of Userdir configuration variable.
$   DOC_SUBDIR = "WWWDoc"	! Homolog of Userdir configuration variable.
$!----------------------------------------------------------------------------
$ crlf = f$fao("!/") 
$!
$ If f$trnlnm("WWW_OUT") .nes. ""
$ Then						! CERN server
$    WWW_IPATH_INFO = "/www/"			! Default Document Directory
$    WWW_IPATH_TRANSLATED = "/WWW_Root/000000/"	! Default Translation
$    say = "write WWW_OUT"
$    put = "create WWW_OUT"
$    define_output   = "!"
$    deassign_output = "!"
$ Else						! OSU server
$    WWW_IPATH_INFO = "/www/"			! Default Document Directory
$    WWW_IPATH_TRANSLATED = "/WWW_Root/documents/" ! Default Translation
$    say = "write net_link"
$    put = "create net_link"
$    define_output   = "define/nolog sys$output net_link"
$    deassign_output = "deassign sys$output"
$    WWW_APPEND_EQUAL_SIGN = "YES"
$    say "<DNETRECMODE>"	! Set implied carriage control
$    mcr 'f$parse("SET_DCL_ENV.EXE;",f$environment("PROCEDURE")) "WWW_"
$ EndIf
$!----------------------------------------------------------------------------
$!
$! If PATH_INFO was included in the URL, replace the IPATH defaults.
$!
$ If "''WWW_PATH_INFO'" .nes. "" .and. "''WWW_PATH_TRANSLATED'" .nes. "" -
	.and. "''WWW_PATH_INFO'" .nes. "''WWW_PATH_TRANSLATED'"
$ Then
$    WWW_IPATH_INFO = WWW_PATH_INFO
$    WWW_IPATH_TRANSLATED = WWW_PATH_TRANSLATED
$ EndIf
$!----------------------------------------------------------------------------
$!
$! Set up a complete BASE URL for ourself if we are not being proxied.
$!
$ If f$locate("http:", WWW_SCRIPT_NAME) .gt. 0
$ Then
$    access = "http://" + f$edit(WWW_SERVER_NAME, "COLLAPSE,LOWERCASE")
$    if WWW_SERVER_PORT .ne. 80 then access = access + ":" + WWW_SERVER_PORT
$ Else
$    access = ""
$ EndIf
$ script = WWW_SCRIPT_NAME + WWW_PATH_INFO
$!----------------------------------------------------------------------------
$!
$! Check whether we have a query or valid form content.
$!
$ If WWW_KEY_COUNT .eq. 0 .or. -
     WWW_KEY_COUNT .gt. 1 .and.WWW_KEY_COUNT .lt. 16 .and. -
     f$edit("''WWW_KEY_1'", "TRIM") .eqs. "kw=" .and. -
     f$edit("''WWW_KEY_2'", "TRIM") .eqs. ""
$ Then
$!
$!  No query or valid form content.  Send Cover Page and exit.
$!  ==========================================================
$!
$   m'default_max_hits_option' = " SELECTED"	! Set default mh
$   say "Content-Type: text/html", crlf		! Send the Header.
$!
$!***** Change the Cover Page, appropriately for your site. *****
$!      ---------------------------------------------------
$!
$   put		! Example of writing via create.
<HTML>
<HEAD>
<TITLE>Search the VMSGopherServer v1.2VMS-1 Documentation</TITLE>
</HEAD>
<BODY>
$! Now use say to permit symbol insertions.
$! ----------------------------------------
$   say "<FORM METHOD=""GET"" ACTION=""''access'''script'"">"
$! Go back to writing via create.
$! ------------------------------
$   put
<H1>VMSGopherServer</H1>
This database is maintained by macrides@sci.wfbr.edu
on host www.wfbr.edu.
<P>The search matches your words against full document text.
Access to this index is provided by the WWW to VMSIndex gateway.
$! Use say again to permit symbol insertions.
$! ------------------------------------------
$   say "Please specify <A HREF=""''access'/www/doc/keywords.html"""
$   say ">keyword(s)</A> to find documents."
$   say "Click <A HREF=""''access'''script'?kw=gopher"""
$! Go back to writing via create.
$! ------------------------------
$   put
>here</A> to use <EM>gopher</EM> as the keyword for fetching a
menu for all 33 sections of this database, or enter keyword(s)
below after making a selection in the popup window to modify the
maximum number of hits returned.</P>
<P><EM>Enter your keyword(s):</EM></P>
<P ALIGN="center"><INPUT NAME="kw" SIZE="60" MAXLENGTH=200></P>
<P ALIGN="center">
<INPUT TYPE="submit" VALUE="Submit"> <INPUT TYPE="reset" VALUE="Reset">
<INPUT TYPE="hidden" NAME="fh" VALUE="1"> <SELECT NAME="mh">
$   gosub ADD_SELECT_OPTIONS
$   say "</SELECT></P></FORM><HR></BODY></HTML>"
$   exit
$ EndIf
$!----------------------------------------------------------------------------
$!
$!  We have a query.  Check if it's a /~username/ database.
$!
$ If f$locate("/~",WWW_IPATH_INFO) .eq. 0
$ Then
$!  It's a /~username/ database.
$!  ============================
$   gosub USER_DATABASE_SETUP
$ Else
$!  It's a server data tree database.
$!  =================================
$   gosub SERVER_DATABASE_SETUP
$ EndIf
$!----------------------------------------------------------------------------
$!
$!  Set up WWWquery options.
$!
$!  Hit list options:
$!  =================
$!  WWW_SEND_RAW_FILE = "YES"	! Send direct URL's without a Range
$!  WWW_ITEMS_FOUND  = "There are <EM>%d</EM> item(s) found" !Default string
$   WWW_ITEMS_FOUND  = "<EM>%d</EM> item(s) were found" !We'll use this string
$!  WWW_ITEMS_LISTED = "Listing <EM>%d</EM> to <EM>%d</EM>"  !Default string
$!  WWW_SHOW_FILETYPE = "YES"	! All text, so don't bother
$!  WWW_MAXIMUM_HITS = 250	! Set conditionally, below.
$!  WWW_STARTING_HIT = 1	! Set conditionally, below.
$   WWW_SHOW_SIZE = "YES"	! Bytes or KB
$!  WWW_SHOW_DATE = "YES"	! DD-MMM-YY, not worthwhile for databases
$!  WWW_SHOW_TIME = "YES"	! Replace -YY with HH:MM for current year
$!  WWW_USE_MDATE = "YES"	! Use last modified date (default is creation)
$!  WWW_SORT = "YES"		! Sort according to the score.
$!  WWW_SHOW_SCORE = "YES"	! Show the score.
$!  WWW_HITS_TARGET = "foo"	! Add TARGET attribute to anchors.
$!
$!  Document options:
$!  =================
$!  WWW_OMIT_PRE_TAG = "YES"			! See header of query.c
$!  WWW_DATADIRECTORY = "HTTP_Root"		! See header of query.c
$!  WWW_FORBIDDEN = "HTTP_Root:[000000]"	! See header of query.c
$   WWW_VMSINDEX_TITLE = "Search the VMSGopherServer v1.2VMS-1 Documentation"
$!
$!  Script options:
$!  ===============
$   WWW_MINIMUM_WORD = "3"	! Ignore keywords smaller than this number.
$!  WWW_SEND_CONTENTS = "YES"	! Send Location: redirect if only one hit.
$!  WWW_OMIT_CONTENT_TYPE = "YES"		! See header of query.c
$!  WWW_OMIT_HEAD = "YES"			! See header of query.c
$!  WWW_OMIT_FOOT = "YES"			! See header of query.c
$!  WWW_VIA_FORM = "YES"			! See header of query.c
$!  WWW_ADD_CONTEXT = "YES"			! See header of query.c
$!  WWW_END_FORM = "YES"			! See header of query.c
$!  WWW_OMIT_IPATH_CONVERSION = "YES"		! See header of query.c
$!
$!----------------------------------------------------------------------------
$!
$! Check for ?IDENT=<unique_identifier>  The "IDENT=" (instead of "kw=" or
$! "TEXT=") can be used as a flag in an HREF or URL to set WWW_SEND_CONTENTS
$! and force return of the document if the identier is found and it is the
$! only hit.
$!
$ If WWW_KEY_COUNT .eq. 2 .and. -
     f$edit("''WWW_KEY_1'", "TRIM") .eqs. "IDENT="
$ Then
$    query = f$edit(WWW_KEY_2, "TRIM, LOWERCASE")
$    WWW_SEND_CONTENTS = "YES"
$    goto do_it
$ EndIf
$!----------------------------------------------------------------------------
$!
$! Check for ?TEXT=<selector>  This could be from a hit list, or from an
$! explicit reference in an anchor's HREF or a posted URL.
$!
$ If WWW_KEY_COUNT .eq. 2 .and. -
     f$edit("''WWW_KEY_1'", "TRIM") .eqs. "TEXT="
$ Then
$    query = "TEXT=" + f$edit(WWW_KEY_2, "TRIM, LOWERCASE")
$    goto do_it
$ EndIf
$!----------------------------------------------------------------------------
$!
$! Check for an ISINDEX query.  It could be a unique identifier without the
$! IDENT field, or a standard ISINDEX query designed to fetch a particular
$! set of sections, or all the sections via "?gopher" instead of "?kw=gopher".
$! Once invoked in this mode, if there is more than one hit, a hit list with
$! ISINDEX in it's HEAD will be returned, and we will continue behaving as
$! an ISINDEX search engine via queries on that list.
$!
$ If f$edit("''WWW_KEY_1'", "TRIM") .nes. "kw="
$ Then
$    query = WWW_KEY_1
$    WWW_MAX_HITS = 50
$    WWW_SEND_CONTENTS = "YES"
$    num = 2
$ISINDEX_Loop:
$    If (WWW_KEY_COUNT - num) .ge. 0 
$    Then
$	query = query + " " + WWW_KEY_'num'
$	num = num + 1
$	goto ISINDEX_Loop
$    EndIf
$    goto do_it
$ EndIf
$!----------------------------------------------------------------------------
$!
$! Check for a First, Pevious, Next of Last request.
$!
$ If WWW_KEY_COUNT .ge. 16
$ Then
$    If f$edit("''WWW_KEY_15'", "TRIM") .eqs. "oq="
$    Then
$       query = f$edit(WWW_KEY_16, "TRIM, LOWERCASE")
$       WWW_MAXIMUM_HITS = WWW_KEY_12
$       m'WWW_KEY_12' = " SELECTED"
$       submit_value = f$edit(WWW_KEY_8, "UPCASE, TRIM")
$	os_value = WWW_KEY_10
$    Else
$!!!!!!!Spyglass appends the NAMEd SUBMIT to the end of the content.
$       query = f$edit(WWW_KEY_14, "TRIM, LOWERCASE")
$       WWW_MAXIMUM_HITS = WWW_KEY_10
$       m'WWW_KEY_10' = " SELECTED"
$       submit_value = f$edit(WWW_KEY_16, "UPCASE, TRIM")
$	os_value = WWW_KEY_8
$    EndIf
$    If f$locate("FIRST", submit_value) .eq. 0
$    Then
$	WWW_STARTING_HIT = 1
$	goto set_up_form
$    EndIf
$    If f$locate("PREVIOUS", submit_value) .eq. 0
$    Then
$	WWW_STARTING_HIT = f$string('os_value' - 'WWW_MAXIMUM_HITS')
$	goto set_up_form
$    Endif
$    If f$locate("NEXT", submit_value) .eq. 0 .or. -
	f$locate("LAST", submit_value) .eq. 0
$    Then
$	WWW_STARTING_HIT = f$string('os_value' + 'WWW_MAXIMUM_HITS')
$	goto set_up_form
$    EndIf
$ Endif
$!----------------------------------------------------------------------------
$!
$! If we get to here, it's a standard form submission or emulation.
$! Reconstruct the query (unescaped), and set up the hit range.
$!
$ query = f$edit(WWW_KEY_2, "TRIM, LOWERCASE")
$ If WWW_KEY_COUNT .ge. 6
$ Then
$    WWW_STARTING_HIT = WWW_KEY_4
$    WWW_MAXIMUM_HITS = WWW_KEY_6
$    m'WWW_MAXIMUM_HITS' = " SELECTED"
$ Else
$    WWW_STARTING_HIT = 1
$    m'default_max_hits_option' = " SELECTED"
$ EndIf
$!----------------------------------------------------------------------------
$!
$! Set up a form before calling the search engine.
$!
$set_up_form:
$ WWW_VIA_FORM = "YES"
$ WWW_OMIT_CONTENT_TYPE = "YES"
$ WWW_OMIT_HEAD = "YES"
$ WWW_ADD_CONTEXT = "YES"
$ WWW_END_FORM = "YES"
$ put
Content-Type: text/html

<HTML>
<HEAD>
<TITLE>Search the VMSGopherServer v1.2VMS-1 Documentation</TITLE>
</HEAD>
<BODY>
$ say "<FORM METHOD=""GET"" ACTION=""''access'''script'"">"
$ say "<H3><EM>Refine your choice of"
$ say "<A HREF=""''access'/www/doc/keywords.html"">keyword(s)</A>"
$ say "here:</EM></H3><P ALIGN=""center"">"
$ say "<INPUT NAME=""kw"" SIZE=""60"" MAXLENGTH=200 VALUE=""''query'""></P>"
$ put
<P ALIGN="center">
<INPUT TYPE="submit" VALUE="Submit"> <INPUT TYPE="reset" VALUE="Reset">
<INPUT TYPE="hidden" NAME="fh" VALUE="1"> <SELECT NAME="mh">
$ gosub ADD_SELECT_OPTIONS
$ say "</SELECT></P><HR>"
$!----------------------------------------------------------------------------
$!
$! Do the search or RANGE (TEXT=<selector>) fetch.
$!
$do_it:
$ define_output
$ WWWquery "''database'" "''query'"
$ deassign_output
$ exit
$!
$!***************** USER_DATABASE_SETUP SUBROUTINE ***************************
$! Convert database to device:[...username.INDEX_SUBDIR]database
$! Convert WWW_IPATH_TRANSLATED to device:[...username.DOC_SUBDIR]docfile
$!   if it's a fetch, or /device/.../username/DOC_SUBDIR/ if it's a search
$!
$ USER_DATABASE_SETUP:
$ username = f$edit(f$extract(2,f$length(f$element(1,"/",WWW_IPATH_INFO))-1,-
		    WWW_IPATH_INFO), "UPCASE")
$ length = f$locate(username,WWW_IPATH_TRANSLATED)+f$length(username)
$ WWW_IPATH_TRANSLATED = f$extract(0,length,WWW_IPATH_TRANSLATED)
$ INDEX_DIR = f$extract(1,f$length(WWW_IPATH_TRANSLATED)-1,-
			  WWW_IPATH_TRANSLATED)
$ num = 0
$ indexdir = f$element(num,"/",INDEX_DIR) + ":["
$ subdir_loop:
$ num = num + 1
$ subdir = f$element(num,"/",INDEX_DIR)
$ If subdir .nes. "/" .and. subdir .nes. ""
$ Then
$   indexdir = indexdir + subdir + "."
$   goto subdir_loop
$ EndIf
$ INDEX_DIR = indexdir + "''INDEX_SUBDIR']"
$ database = INDEX_DIR + database
$!
$ If f$locate("TEXT=R",WWW_QUERY_STRING) .eq. 0
$ Then
$!  It's a fetch.
$!  =============
$   offset = f$locate(WWW_IPATH_INFO,WWW_QUERY_STRING)+ -
			f$length(WWW_IPATH_INFO)
$   docfile = f$extract(offset,f$length(WWW_QUERY_STRING)-offset, -
			WWW_QUERY_STRING)
$   WWW_IPATH_TRANSLATED = f$extract(0,f$locate("''INDEX_SUBDIR]",INDEX_DIR),-
			INDEX_DIR) + "''DOC_SUBDIR']" + docfile
$ Else
$!  It's a search.
$!  ==============
$   WWW_IPATH_TRANSLATED = WWW_IPATH_TRANSLATED+"/''DOC_SUBDIR'/"
$ EndIf
$ RETURN   
$!************************ END USER_DATABASE_SETUP ***************************
$!
$!***************** SERVER_DATABASE_SETUP SUBROUTINE *************************
$! Prefix INDEX_SUBDIR to database
$! If it's a fetch, convert WWW_IPATH_TRANSLATED to the full VMS pathspec
$!   for the docfile.  Otherwise, don't change the IPATH symbols.
$!
$ SERVER_DATABASE_SETUP:
$ database = INDEX_DIR + database
$ If f$locate("TEXT=R",WWW_QUERY_STRING) .eq. 0
$ Then
$!  It's a fetch.
$!  =============
$   offset = f$locate("''DOC_REF'", WWW_QUERY_STRING)+f$length("''DOC_REF'")
$   docfile = f$extract(offset,f$length(WWW_QUERY_STRING)-offset, -
			WWW_QUERY_STRING)
$   DOC_DIR = WWW_IPATH_TRANSLATED + DOC_REF
$   num = 1
$   docdir = f$element(num,"/",DOC_DIR) + ":["
$ docdir_loop:
$   num = num + 1
$   subdir = f$element(num,"/",DOC_DIR)
$   If subdir .nes. "/" .and. subdir .nes. ""
$   Then
$      docdir = docdir + subdir + "."
$      goto docdir_loop
$   EndIf
$   DOC_DIR = f$extract(0,f$length(docdir)-1,docdir) + "]"
$   WWW_IPATH_TRANSLATED = DOC_DIR + docfile
$ EndIf
$ RETURN   
$!*********************** END SERVER_DATABASE_SETUP **************************
$!
$!******************** ADD_SELECT_OPTIONS SUBROUTINE *************************
$! Prefix INDEX_SUBDIR to database
$! If it's a fetch, convert WWW_IPATH_TRANSLATED to the full VMS pathspec
$!   for the docfile.  Otherwise, don't change the IPATH symbols.
$!
$ ADD_SELECT_OPTIONS:
$ say "<OPTION VALUE=""5""''m5'>5 items returned, Max."
$ say "<OPTION VALUE=""10""''m10'>10 items returned, Max."
$ say "<OPTION VALUE=""25""''m25'>25 items returned, Max."
$ say "<OPTION VALUE=""50""''m50'>50 items returned, Max."
$ say "<OPTION VALUE=""100""''m100'>100 items returned, Max."
$ say "<OPTION VALUE=""150""''m150'>150 items returned, Max."
$ say "<OPTION VALUE=""250""''m250'>250 items returned, Max."
$ say "<OPTION VALUE=""500""''m500'>500 items returned, Max."
$ say "<OPTION VALUE=""1000""''m1000'>1000 items returned, Max."
$ RETURN   
$!*********************** END ADD_SELECT_OPTIONS ****************************
